
; Asar directives
hirom


; =============================[ Optimizations ]===============================

org $C3520F

; Build Lore list
C3520F:  LDA #$02        ; Lores: 24
         LDX #$1D29      ; Known Lores adr

; Build a list of learned skills
bldskl:  STA $E1         ; Set byte count			<- Could use stack
         LDY #$9D89      ; 7E/9D89
         STY $2181       ; Set WRAM LBs
         STZ $E0         ; Skill number: 0
.loop1   LDY #$0008      ; Skills left: 8
         LDA $00,X       ; 8 known skills
.loop2   LSR A           ; Knowing current?
         PHA             ; Save 8 skills
         LDA $E0         ; Skill number
         BCS .store      ; Retain if known
         LDA #$FF        ; Skill: None
.store   STA $2180       ; Add to list
         INC $E0         ; Skill number +1
         PLA             ; 8 known skills
         DEY             ; Skills left -1
         BNE .loop2      ; Loop till last
         INX             ; Point to next 8
         DEC $E1         ; One less byte
         BPL .loop1      ; Loop till last
         RTS

warnpc $C3523C : print pc, " / C3523C [Build Lore or skill list]"

; -----------------------------------------------------------------------------

org $C3536E

; Build SwdTech list
C3536E:  LDX #$1CF7      ; Known techs adr
         JMP bldskl      ; Build tech list
C3536_:

; -----------------------------------------------------------------------------

org $C35486

; Build sorted esper list
C35486:  LDA #$03        ; Espers: 32
         LDX #$1A69      ; Owned espers adr
         JSR bldskl      ; Build basic list

; Fork: Move unsorted list to a buffer
         LDX #$001F      ; Esper slot: 32
.loop    LDA $7E9D89,X   ; Esper in slot
         STA $7E9DED,X   ; Copy to buffer			<- Could use stack instead, with some changes
         LDA #$FF        ; Esper: None
         STA $7E9D89,X   ; Clear src slot
         DEX             ; Esper slot -1
         BPL .loop       ; Loop till < 0

; Fork: Sort esper list
C354C3:  TDC             ; Clear A
         LDX #$001A      ; Buffer slot: 27			<- Ignores 5 unused esper bits, unlike code above (vanilla game does it this way)
C354CD:  PHX             ; Save src slot
         LDA $7E9DED,X   ; Esper in slot
         BMI C354DF      ; Skip if none
         PHA             ; Memorize it
         TAX             ; Index it
         LDA $D1F9B5,X   ; Intended slot
         DEC A           ; Subtract 1				<- Could remove this and use STA $7E9D88,X
         TAX             ; Index it
         PLA             ; Esper number
         STA $7E9D89,X   ; Add to new list
C354DF:  PLX             ; Source slot
         DEX             ; Source slot -1
         BPL C354CD      ; Loop till < 0
         RTS
C3548_:

; -----------------------------------------------------------------------------

org $C3561B

; Build Blitz list
C3561B:  LDX #$1D28      ; Known Blitzes adr
         BRA C35623      ; Skip a line

; Build Dance list
C35620:  LDX #$1D4C      ; Known Dances adr
C35623:  TDC             ; Skills: 8
         JMP bldskl      ; Build skill list
C3561_:


; =============================[ Segment edits ]===============================

org $C321CF

; Initialize Rage menu
         INC $3A         ; BG2 X-Pos: 256			<- Both INCs are optimizations to insert JSR
         INC $3E         ; BG3 X-Pos: 256
         JSR ragemet     ; List enemies met

warnpc $C321D6


; ==========================[ Rage menu redesign ]=============================

org C3561_

; Build list of enemies roaming Veldt
ragemet: LDX #$00FF      ; Slot: Last
         TXA             ; Enemy: None
.loop1   STA $7EAA8D,X   ; Clear slot
         DEX             ; List slot -1
         BPL .loop1      ; Loop till < 0

; Fork: Build list of encountered enemies
         INX             ; 8-pack index: 0
         STX $E0         ; Group index: 0

; Fork: Mark enemies met from 8 groups
.loop2   LDY #$0008      ; Groups left: 8
         LDA $1DDD,X     ; 8 met-group flags
         JSR mark6x8     ; Mark enemies met

; Fork: Handle next 8-group pack
         BNE .loop2      ; If not last pack
         RTS

warnpc $C35643 : print pc, " / C35643 [List enemies met]"



org C3548_

; Mark Rage-compatible enemies in 8 groups as met
mark6x8: PHX             ; Save pack index
.loop1   LSR A           ; Met current group?
         PHY             ; Save group counter
         PHA             ; Save group flags
         BCC .next       ; Skip if not
         TDC             ; Clear A
         LDX $E0         ; Group data index
         LDY #$0006      ; Enemies: 6
         JSR mark6x1     ; Mark enemies met

; Fork: Handle next group from 8-pack
.next    LDA #$0F        ; Loop counter
         LDY $E0         ; Group data index
.loop2   INY             ; Index +1
         DEC A           ; Counter -1
         BNE .loop2      ; Loop till 0
         STY $E0         ; Save updated index
         PLA             ; 8 met-group flags
         PLY             ; Groups remaining
         DEY             ; One less group
         BNE .loop1      ; Loop till 8th
         PLX             ; Pack index
         INX             ; Pack index +1
         CPX #$0040      ; Done all 64?
         RTS

warnpc $C354E3 : print pc, " / C354E3 [Include 8 groups]"



org C3536_

; Mark Rage-compatible enemies in group as met
mark6x1: LDA $CF620E,X   ; 6 enemy num MSB
.loop    LSR A           ; Enemy num > 255?
         BCS .next       ; Skip enemy if so
         PHX             ; Save enemy slot
         PHA             ; Save nums MSBs
         LDA $CF6202,X   ; Enemy number
         TAX             ; Index it
         INC A           ; Pugs?
         BEQ .store      ; Branch if so				<- Stores #$00 for Pugs instead of #$FF (null value)
         TXA             ; Enemy number
.store   STA $7EAA8D,X   ; Mark enemy as met
         PLA             ; 6 enemy num MSB
         PLX             ; Enemy slot
.next    INX             ; Enemy slot +1
         DEY             ; One less enemy
         BNE .loop       ; Loop till 6th
         RTS

warnpc $C35391 : print pc, " / C35391 [Include 1 group]"

; -----------------------------------------------------------------------------

org $C35418

; Draw Rage name
C35418:  LDA $E6         ; BG1 write row
         INC A           ; Go 1 row down			<- Likely to skip diacritic row (SFC)
         JSR $809F       ; Compute map ptr
         TAY             ; Put it in Y
         JSR $3519       ; Set position
         JSR rgcolor     ; Define color

; Fork: Blank slot if inaccessible Rage
         TXA             ; Enemy number
         BEQ .draw       ; Draw if Guard			<- Allows user to use its value to dummy out entries in table of Rage slots to leave blank
         LDX #$0003      ; Ban table index
.loop    CMP.L rg_ban,X  ; Banned Rage?
         BEQ C3543B      ; Blank if so
         DEX             ; Table index -1
         BPL .loop       ; Loop till < 0

; Fork: Draw Rage name
.draw    JSR $8467       ; Load name
         JMP $7FD9       ; Draw name

; Fork: Blank Rage slot
C3543B:  JMP $555D       ; Draw 12 spaces			<- Reuses Esper menu code to save space (only need 10 spaces)

; Rage slots to leave blank					<- To remove a list entry, change it to "db $00"
rg_ban:  db $37          ; Siegfried
         db $40          ; Chupon
         db $BB          ; Allo Ver
         db $FF          ; Pugs

C3541_:

warnpc $C35452

; -----------------------------------------------------------------------------

org $C353C1

; Build Rage list
C353C1:  LDA #$1F        ; Rages: 256
         LDX #$1D2C      ; Known Rages adr
         JSR bldskl      ; Build Rage list
         BCC .exit       ; If missing Pugs
;        TDC             ; Non-null value
         STA $7E9E88     ; Unlock Pugs Rage
.exit    RTS

; Define Rage's text color
rgcolor: JSR $C2F2       ; Color: User's
         JSR $50EC       ; Rage in slot
         INC A           ; Learned it?
         BNE .exit       ; Lit if so
         LDA #$28        ; Palette 2
         STA $29         ; Color: Gray
         TXA             ; Enemy number
         CMP #$FF        ; Pugs?
         BNE .skip       ; Retain if not
         TDC             ; Pugs's tbl value			<- Table value is defined in "mark6x1" function above
.skip    CMP $7EAA8D,X   ; Roams Veldt now?
         BNE .exit       ; Gray out if not
         LDA #$24        ; Palette 1				<- Use #$2C for gray-and-blue palette from Magic menu
         STA $29         ; Color: Turquoise
.exit    RTS

warnpc $C353EE : print pc, " / C353EE [Rage list, color]"


; =======================[ Unlock Rage menu by default ]=======================

org $C34D6B ; Unlock "Rage" by default
         PLX            ; Actor's address			<- Formerly PLY, allows for LDA $0000,Y -> LDA $00,X below
         JSR unlk_rg    ; Call fn below


org C3541_

; Unlock Rage menu by default
unlk_rg: LDA #$20        ; Color: User's
         STA $7E         ; Unlock Rage menu
         LDA $00,X       ; Actor				<- Code removed from function above to insert JSR there
         RTS

warnpc $C35452 : print pc, " / C35452 [Draw 1 Rage, etc.]"
